#include<stdio.h>
#include<stdlib.h>
#include<vector>
#include<algorithm>
#include<set>

using namespace std;


int ncases, ndays, ningredients,nrecipes,e,g,l,i, minday, score;
vector<int> expiracy;

vector<pair<int,int>> recipes;
multiset<int> deadlines;

bool doable(){
    bool ans=true;
    int d=1;
    for (auto it = deadlines.begin(); it!=deadlines.end(); it++,d++){
        ans &= (*it>=d);
    }
    return ans;
}

int main(){
    scanf("%d",&ncases);
    for (int ncase=0; ncase<ncases; ncase++){
        expiracy.clear();
        recipes.clear();
        deadlines.clear();
        scanf("%d %d %d",&ndays,&ningredients,&nrecipes);
        for (int i=0; i<ningredients;i++){
            scanf("%d",&e);
            expiracy.push_back(e);
        }        
        for (int r=0; r<nrecipes; r++){
            scanf("%d %d",&g,&l);
            minday=ndays;
            for (int j=0; j<l; j++){
                scanf("%d",&i);
                minday = ((expiracy[i-1]<minday)?expiracy[i-1]:minday);
            }
            recipes.emplace_back(-g,minday);
        }        
        sort(recipes.begin(),recipes.end());
        score=0;
        for (auto it = recipes.begin(); it!=recipes.end(); it++){
            deadlines.insert(it->second);
            if (doable()){
                score-=it->first;
            }
            else {
                deadlines.erase(deadlines.find(it->second));
            }
            
        }
        printf("%d\n", score);
    }


    return 0;
}
