#!/usr/bin/python3

import sys

MAX=100000
MAXG=100
MAXNUM=10

def parse1(l):
    x = int(l)
    assert (l == (str(x) + "\n"))
    return x

def parse3(l):
    f = l.split(" ")
    assert(len(f) == 3)
    x = int(f[0])
    y = int(f[1])
    z = int(f[2])
    assert (l == (str(x) + " " + str(y) + " " + str(z) + "\n"))
    return x, y, z

def parsen(l):
    f = l.split(" ")
    x = [int(xx) for xx in f]
    assert (l == " ".join(str(y) for y in x) + "\n")
    return x

ncases_l = sys.stdin.readline()
ncases = parse1(ncases_l)

for ncase in range(ncases):
    d_l = sys.stdin.readline()
    nn, ni, nr = parse3(d_l)
    assert (1 <= nn <= MAX)
    assert (1 <= ni <= MAX)
    assert (1 <= nr <= MAX)

    d_l2 = sys.stdin.readline()
    vv = parsen(d_l2)
    assert(len(vv) == ni)
    for v in vv:
        assert (1 <= v <= MAX)

    for i in range(nr):
        ll = sys.stdin.readline()
        ww = parsen(ll)
        grade = ww[0]
        assert(1 <= grade <= MAXG)
        num = ww[1]
        assert(1 <= num <= MAXNUM)
        assert(len(ww) == num + 2)
        for x in ww[2:]:
            assert (1 <= x <= ni)


# check if EOF is reached
rest = sys.stdin.read()
assert(len(rest) == 0)

