#include<stdio.h>
#include<vector>

// génère des cas avec n grand premier (trop long en fait!)

using namespace std;

int lim = 10;

unsigned long long int m,n,k,alpha,ncases,tortoise,hare,lam,mu,lmax,kmax,alphamax;

unsigned long long move(unsigned long long x){
    return (k+alpha*x*x)%n;
}

vector<unsigned long long int> list_n  = {1073741827 , 4294967311 , 17179869209 , 68719476767 , 274877906951 , 1099511627791 , 4398046511119 , 17592186044423 , 70368744177679 , 281474976710677 , 1125899906842679 , 4503599627370517 , 18014398509482143 , 72057594037928017 , 288230376151711813};

int main(){
    printf("%lu\n",list_n.size());
    lmax=0;
    kmax=0;
    alphamax=0;
    for (auto it =list_n.begin(); it!=list_n.end() ; it++){
        n=*it;
        for (k=1 ; k<lim; k ++){
            for (alpha=1 ; alpha < lim; alpha++){
            
                tortoise=move(k);
                hare=move(move(k));
            
    //            printf("%llu %llu\n ", tortoise, hare);
            
                // positionnement des indices à un point de rencontre
                while (tortoise!=hare) {
                    tortoise=move(tortoise);
                    hare=move(move(hare));
                }
                // calcul du 1er point de rencontre mu
                mu=0;
                tortoise=k;
                while (tortoise!=hare) {
                    tortoise=move(tortoise);
                    hare=move(hare);
                    mu+=1;
                }
                // calcul de la période lam
                lam=1;
                hare=move(tortoise);
                while (tortoise!=hare) {
                    hare=move(hare);
                    lam+=1;
                }
                if (lam+mu>lmax){
                    lmax=lam+mu;
                    kmax=k;
                    alphamax=alpha;
//                    printf("k = %llu  alpha = %llu \n", k, alpha);
//                    printf("%llu %llu %llu \n", lam+mu, lam, mu);
                }
                
                
            }
        }
        printf("%llu %llu %llu\n",n,kmax,alphamax);
    }
}
