#include<stdio.h>

// solution proposée par Bertrand
// supposée passer en temps


using namespace std;

unsigned long long int n,k,alpha,ncases,tortoise,hare,lam,mu;

inline unsigned long long int move(unsigned long long int x){
    return (k+alpha*x*x)%n;
}

int main(){
    scanf("%llu",&ncases);
    for (int ncase=0; ncase<ncases; ncase++){
        scanf("%llu %llu %llu",&n,&k,&alpha);
        tortoise=move(k);
        hare=move(move(k));
        // positionnement des indices à un point de rencontre
        while (tortoise!=hare) {
            tortoise=move(tortoise);
            hare=move(move(hare));
        }
        // calcul du 1er point de rencontre mu
        mu=0;
        tortoise=k;
        while (tortoise!=hare) {
            tortoise=move(tortoise);
            hare=move(hare);
            mu+=1;
        }
        // calcul de la période lam
        lam=1;
        hare=move(tortoise);
        while (tortoise!=hare) {
            hare=move(hare);
            lam+=1;
        }
        printf("%llu\n", lam+mu  );
            
    }
}
