#!/usr/bin/python3

import sys

MAX=200000000
MAXA=100

def parse1(l):
    x = int(l)
    assert (l == (str(x) + "\n"))
    return x

def parsen(l):
    f = l.split(" ")
    x = [int(xx) for xx in f]
    assert (l == " ".join(str(y) for y in x) + "\n")
    return x

ncases_l = sys.stdin.readline()
ncases = parse1(ncases_l)

for ncase in range(ncases):
    d_l = sys.stdin.readline()
    v = parsen(d_l)
    assert(len(v) == 3)
    n = v[0]
    assert(2 <= n <= MAX)
    assert(0 <= v[1] <= n-1)
    assert(1 <= v[2] <= n-1)
    assert(1 <= v[2] <= MAXA)


# check if EOF is reached
rest = sys.stdin.read()
assert(len(rest) == 0)

