#!/usr/bin/python3

import sys

MAX=5

def parse1(l):
    x = int(l)
    assert (l == (str(x) + "\n"))
    return x

def parsen(l):
    f = l.split(" ")
    x = [int(xx) for xx in f]
    assert (l == " ".join(str(y) for y in x) + "\n")
    return x

ncases_l = sys.stdin.readline()
ncases = parse1(ncases_l)

for ncase in range(ncases):
    M = []
    for i in range(8):
        d_l = sys.stdin.readline()
        v = parsen(d_l)
        assert(len(v) == 8)
        for x in v:
            assert (0 <= x <= MAX)
        M.append(v)
    for i in range(8):
        assert(M[i][i] == 0)
    for i in range(8):
        for j in range(8):
            if (i != j):
                assert(M[i][j] + M[j][i] > 0)

# check if EOF is reached
rest = sys.stdin.read()
assert(len(rest) == 0)

