#!/usr/bin/python3

import sys

MAXL=30
MAXR=50

def parse1(l):
    x = int(l)
    assert (l == (str(x) + "\n"))
    return x

def parse2(l):
    f = l.split(" ")
    assert(len(f) == 2)
    x = int(f[0])
    y = int(f[1])
    assert (l == (str(x) + " " + str(y) + "\n"))
    return x, y

ncases_l = sys.stdin.readline()
ncases = parse1(ncases_l)

for ncase in range(ncases):
    d_l = sys.stdin.readline()
    l, r = parse2(d_l)
    assert(0 <= l <= MAXL)
    assert(l <= r <= MAXR)


# check if EOF is reached
rest = sys.stdin.read()
assert(len(rest) == 0)

