#!/usr/bin/python3

from random import choice, shuffle

vals_lo = ["00", "01", "10", "1F", "70", "7F"]
vals_hi = ["80", "81", "E0", "EF", "F0", "FE", "FF"]

hex_chars = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
        'A', 'B', 'C', 'D', 'E', 'F']
x = []

# all values with random choice of byte codings
for i in range(1024):
    for times in range(5):
        o = []
        for b in range(10):
            if (i % (2**b)):
                o.append(choice(vals_lo))
            else:
                o.append(choice(vals_hi))
        x.append(" ".join(o))

# 2000 random values
for times in range(2000):
    o = []
    for b in range(10):
        o.append(choice(hex_chars) + choice(hex_chars))
    x.append(" ".join(o))

shuffle(x)
 
sizes = [2, 2, 3, 5, 10, 15, 100, 500, 1000, 0]
sizes[-1] = len(x) - sum(sizes)
 
thesum = 0
for i in range(len(sizes)):
    outfile = "out" + str(i) + ".in"
    posf = thesum
    post = thesum + sizes[i]
    with open(outfile, 'w') as fh:
        print(sizes[i], file=fh)
        print("\n".join(x[posf:post]), file=fh)
    thesum += sizes[i]

