#!/usr/bin/python3

from random import randint, sample, shuffle

data = []
MAX=100000

def gencase(nn, ni, nr, maxexp, maxgrade, maxnumingr):
    global data
    case = [str(nn) + " " + str(ni) + " " + str(nr)]
    # generate the expiries
    l2 = []
    for i in range(ni):
        l2.append(randint(1, maxexp))
    case.append(" ".join(str(x) for x in l2))
    # generate the recipes
    for r in range(nr):
        grade = randint(1, maxgrade)
        numingr = randint(1, min(maxnumingr, ni))
        ingrs = sample(range(1, ni+1), numingr)
        case.append(str(grade) + " " + str(numingr) + " " +
                " ".join(str(x) for x in ingrs))
    data.append("\n".join(case))

for nn in [1, 2, 5]:
    for ni in [1, 2, 500]:
        for nr in [1, 2, 500]:
            for maxexp in [1, 5, 100]:
                for maxgrade in [1, 10, 100]:
                    for maxnumingr in [1, 2, 10]:
                        gencase(nn, ni, nr, maxexp, maxgrade, maxnumingr)

# the big ones
gencase(MAX, 10, 10, MAX, 100, 10)
gencase(1000, MAX, MAX, 1100, 100, 10)
gencase(MAX, MAX, MAX, MAX, 100, 10)
gencase(MAX, MAX, MAX, MAX, 100, 1)
gencase(MAX, MAX, MAX, MAX, 1, 10)

sizes = [2, 2, 3, 5, 10, 15, 20, 50, 100, 0]
sizes[-1] = len(data) - sum(sizes)

shuffle(data)
thesum = 0
for i in range(len(sizes)):
    outfile = "out" + str(i) + ".in"
    posf = thesum
    post = thesum + sizes[i]
    with open(outfile, 'w') as fh:
        print(sizes[i], file=fh)
        print("\n".join(data[posf:post]), file=fh)
    thesum += sizes[i]

