#include<cstdio>
#include<vector>
#include<algorithm>
#include<queue>

using namespace std;

#define MAXN 1000003
#define MAXI 1000003
#define MAXR 1000003

typedef unsigned long long ull;

int main() {
  int ncases;
  scanf("%d", &ncases);
  for (int ncase = 0; ncase < ncases; ncase++) {
    int n, ni, nr;
    scanf("%d%d%d", &n, &ni, &nr);
    int expir[MAXI];
    for (int i = 0; i < ni; i++)
      scanf("%d", &(expir[i+1]));
    vector<pair<int, int>> rec;
    for (int r = 0; r < nr; r++) {
      int grade, ningr;
      scanf("%d%d", &grade, &ningr);
      int rexpir = MAXN;
      for (int i = 0; i < ningr; i++) {
        int iv;
        scanf("%d", &iv);
        rexpir = min(rexpir, expir[iv]);
      }
      rec.push_back(make_pair(-rexpir, grade));
    }
    sort(rec.begin(), rec.end());
    priority_queue<ull> Q;
    int idx = 0;
    ull score = 0;
    for (int d = n; d > 0; d--) {
      while (idx < nr && -rec[idx].first >= d) {
        Q.push(rec[idx].second);
        idx++;
      }
      // make the best dish
      if (!Q.empty()) {
        score += Q.top();
        Q.pop();
      }
    }
    printf("%lld\n", score);
  }
}

