#!/usr/bin/python3

from random import random, shuffle

data = []

def gen_case(d, prob_ground, prob_food):
    global data
    case = []
    case.append(str(d))
    for k in range(d*2-1):
        lenline = 2*d - 1 - int(abs((k+1) - d))
        lenline_with_inner_spaces = 2*lenline - 1
        num_spaces = int((4*d-3) - lenline_with_inner_spaces)
        assert(num_spaces % 2 == 0)
        num_spaces_sides = int(num_spaces/2)
        cells = []
        for l in range (d+min(k, 2*d-1-k-1)):
            if random() <= prob_ground:
                if random() <= prob_food:
                    cells.append("F")
                else:
                    cells.append("L")
            else:
                cells.append("W")
        if (k == d-1):
            cells[d-1] = "W"
        case.append(" "*num_spaces_sides +
            " ".join(cells) + " "*num_spaces_sides)
    data.append("\n".join(case))

for d in [1, 2, 3, 5, 10, 20, 40]:
    for prob_ground in [0, 0.01, 0.1, 0.3, 0.5, 0.9, 1]:
        for prob_food in [0, 0.01, 0.1, 0.2, 0.4, 0.5, 0.8, 0.99, 1]:
            gen_case(d, prob_ground, prob_food)

# big

gen_case(100, 0, 0)
gen_case(100, 0.01, 0)
gen_case(100, 0.01, 0.5)
gen_case(100, 0.01, 1)
gen_case(100, 0.2, 0)
gen_case(100, 0.2, 0.1)
gen_case(100, 0.2, 0.5)
gen_case(100, 0.2, 0.9)
gen_case(100, 0.2, 1)
gen_case(100, 0.4, 0)
gen_case(100, 0.4, 0.1)
gen_case(100, 0.4, 0.9)
gen_case(100, 0.4, 1)
gen_case(100, 0.8, 0)
gen_case(100, 0.8, 0.1)
gen_case(100, 0.8, 0.5)
gen_case(100, 0.8, 0.9)
gen_case(100, 0.8, 1)
gen_case(100, 1, 0)
gen_case(100, 1, 0.1)
gen_case(100, 1, 0.5)
gen_case(100, 1, 0.9)
gen_case(100, 1, 1)

shuffle(data)

print(len(data))
print("\n".join(data))

