#include<stdio.h>
#include<stdlib.h>
#include<cstring>
#include<iostream>
#include <cmath>
#include <set>
#include <algorithm>

const double EPS = 10e-11;

// bruteforce pas optimisé ! 


using namespace std;

const int nteams=8;

int perm[nteams],R[nteams][nteams],bestperm[nteams];
double score[nteams][3],P[nteams][nteams],bestscore;

void calcul(){
    for (int t=0 ; t<nteams; t++){
        score[t][0] = P[perm[t]][perm[t^1]];
    }
    for (int r=1;r<3;r++){
        for (int t=0;t<nteams;t++){
            score[t][r]=0;
            for (int s=(1<<r) ; s<(1<<(r+1)) ; s++){
                score[t][r] += P[perm[t]][perm[t^s]]*score[t^s][r-1];
            }
            score[t][r] *=score[t][r-1];            
        }
    }
}

int main(){
    int ncases;
    scanf("%d",&ncases);
    for (int ncase=0 ; ncase<ncases ; ncase++){
        //printf("Case # %d\n",ncase);
        bestscore=-1;
        for (int i=0;i<nteams;i++){
            perm[i]=i;
            for (int j=0;j<nteams;j++){
                scanf("%d", &R[i][j]);
            }
        }

        for (int i=0;i<nteams;i++){
            for (int j=0;j<nteams;j++){
                if (i!=j) {
                    P[i][j] = (double) R[i][j]/(R[i][j]+R[j][i]);
                }
            }
        }


        do {
            calcul();
            
            
            int index=0;
            for (; index<nteams ; index++){
                if (perm[index]==0) {
                    break;
                }
            }

//            printf("%d\n",score[index][2]);

            
            if (score[index][2] > bestscore + EPS) {
                bestscore=score[index][2];
                for (int i=0;i<nteams;i++){
                    bestperm[i] = perm[i];
                }
/*                printf("Meilleur : %d",bestscore);
                for (int i=0;i<nteams;i++){
                    printf(" %d",bestperm[i]);        
                }
                printf("\n");
*/
            }
        } while ( next_permutation(perm,perm+nteams) );
/*
        for (int t=0;t<3;t++){
            for (int i=0;i<nteams;i++){
                printf("%d ",score[i][t]);
            }
            printf("\n");
        }
*/
        printf("%.5lf", bestscore);
        for (int i=0;i<nteams;i++){
            printf(" %d",bestperm[i]);        
        }
        printf("\n");


    }
}
