#!/usr/bin/python3

import sys

hex_chars = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
        'A', 'B', 'C', 'D', 'E', 'F']

def parse1(l):
    x = int(l)
    assert (l == (str(x) + "\n"))
    return x

ncases_l = sys.stdin.readline()
ncases = parse1(ncases_l)

for ncase in range(ncases):
    d_l = sys.stdin.readline()
    assert(d_l[-1] == "\n")
    d_l = d_l[:-1]
    f = d_l.split(" ")
    assert(len(f) == 10)
    for x in f:
        assert (len(x) == 2)
        assert (x[0] in hex_chars)

# check if EOF is reached
rest = sys.stdin.read()
assert(len(rest) == 0)

