#!/usr/bin/python3

from random import sample, randint, shuffle

MAX=100
NUM=10000

choices = set()

for r in range(1, 11):
    for c in range(1, 11):
        choices.add((r, c))

data = []
for i in range(NUM):
    size = randint(0, MAX)
    testcase = []
    testcase.append(str(size))
    s = sample(choices, size)
    for t in s:
        testcase.append("%d %d" % t)
    data.append("\n".join(testcase))

shuffle(data)

 
sizes = [2, 3, 10, 500, 0]
sizes[-1] = len(data) - sum(sizes)
 
shuffle(data)
thesum = 0
for i in range(len(sizes)):
    outfile = "out" + str(i) + ".in"
    posf = thesum
    post = thesum + sizes[i]
    with open(outfile, 'w') as fh:
        print(sizes[i], file=fh)
        print("\n".join(data[posf:post]), file=fh)
    thesum += sizes[i]
