#!/usr/bin/env python3

import sys

hex_chars = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
        'A', 'B', 'C', 'D', 'E', 'F']

def parse1(l):
    x = int(l)
    assert (l == (str(x) + "\n"))
    return x

def parsen(l):
    f = l.split(" ")
    x = [int(xx) for xx in f]
    assert (l == " ".join(str(y) for y in x) + "\n")
    return x

ncases_l = sys.stdin.readline()
ncases = parse1(ncases_l)

for ncase in range(ncases):
    sizel = sys.stdin.readline()
    size = parse1(sizel)
    assert (0 <= size <= 100)
    seen = set()
    for i in range(size):
        l = sys.stdin.readline()
        f = parsen(l)
        assert(len(f) == 2)
        r = f[0]
        c = f[1]
        assert (1 <= r <= 10)
        assert (1 <= c <= 10)
        assert ((r, c) not in seen)
        seen.add((r, c))

# check if EOF is reached
rest = sys.stdin.read()
assert(len(rest) == 0)
